#!/usr/bin/env python
# -- coding: utf-8 --
import os
from distutils.core import setup, Extension, Distribution
from distutils.command.install import install

jukepath = 'src/juke/'
datapath = os.path.join(os.path.expanduser('~'), '.musicquizz') #/home/user/.musicquizz

if not os.path.exists(jukepath+'jukebox.o'):
	os.system('g++ -I. -fpic -c ' + jukepath + 'jukebox.cpp -o ' + jukepath + 'jukebox.o')

if not os.path.exists(datapath):
	os.mkdir(datapath, 0755)

setup(	name = 'musicquizz',
	version = '0.1',
	url = 'http://musicquizz.aditel.org/',
	author = 'Musicquizz team',
	author_email = 'tarragon@aditel.org, victorm@aditel.org, wviana@aditel.org',
	license = 'GPL',
	packages = ['musicquizz'],
	package_dir = {'musicquizz': 'src'},
	scripts = ['scripts/musicquizz'],
	ext_modules = [Extension(	name = 'musicquizz._Jukebox',
					sources = [jukepath+'PyJukebox.cpp'],
					extra_objects = [jukepath+'jukebox.o'],
		  			libraries = ['xine'],
		       			include_dirs = [jukepath] )]
)

