/*Copyright (C) 2007   Authors: Jacobo Tarragón Cros, Víctor Muñoz Ferrara, William Viana Soares. 
Email addresses: tarragon[Aŧ]aditel[DOT]org, victorm[AT]aditel[DOT]org, wviana[AT]aditel[DOT]org
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#include <jukebox.h>
#include <Python.h>

// destructor del objeto
extern "C" void PyDelJukebox(void * ptr){
	Jukebox * oldjuke = static_cast<Jukebox *>(ptr);
	delete oldjuke;
}

// constructor
extern "C" PyObject * wrap_new_Jukebox(PyObject *, PyObject *){
	Jukebox * newjuke = new Jukebox();
	return PyCObject_FromVoidPtr(newjuke, PyDelJukebox);
}

// método stop
extern "C" PyObject * wrap_Jukebox_stop(PyObject *, PyObject * args){
	PyObject * pyjuke = NULL;
	if( ! PyArg_ParseTuple(args, "O", &pyjuke)) return NULL;

	void * temp = PyCObject_AsVoidPtr(pyjuke);
	Jukebox * thisjuke = static_cast<Jukebox *>(temp);

	thisjuke->stop();

	return Py_BuildValue("");
}

// método play
extern "C" PyObject * wrap_Jukebox_play(PyObject *, PyObject * args){

	PyObject * pyjuke = NULL;
	char * s = NULL;
	int i = 0;
	if( ! PyArg_ParseTuple(args, "Os|i", &pyjuke, &s, &i)) return NULL;

	void * temp = PyCObject_AsVoidPtr(pyjuke);
	Jukebox * thisjuke = static_cast<Jukebox *>(temp);

	bool result = thisjuke->play(s,i);

	return Py_BuildValue("b",result);
}

// definición de los métodos para que se reconozcan desde python
static PyMethodDef simpleMethods[] =
{
	{ "new_Jukebox", wrap_new_Jukebox, METH_VARARGS, "" },
	{ "Jukebox_stop", wrap_Jukebox_stop, METH_VARARGS, "" },
	{ "Jukebox_play", wrap_Jukebox_play, METH_VARARGS, "" },
	{ NULL, NULL, 0, NULL}
};

// inicialización del módulo
PyMODINIT_FUNC
init_Jukebox(void){
	(void) Py_InitModule("_Jukebox", simpleMethods);
}

int main(int argc, char * argv[]){
	Py_SetProgramName(argv[0]);

	Py_Initialize();

	init_Jukebox();
}


